package com.dsic.gj_erp.pc;

import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.pc.dto.sb.设备01上料;
import com.dsic.gj_erp.pc.dto.sb.设备02抛丸;
import com.dsic.gj_erp.pc.dto.设备;
import com.google.common.collect.ImmutableMap;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Map;

public interface Constant {
    //手动配置,后期可根据设备进行计算(计算方式根据所有设备的产能合并后的结果,设备维护时不计入产能,休息日产能默认为0)
    ImmutableMap<工序, Double> 工序产能 = ImmutableMap.<工序, Double>builder()
            .put(工序.上料, 200.0)
            .put(工序.抛丸, 200.0)
            .put(工序.理料, 200.0)
            .put(工序.划线, 200.0)

            .put(工序.一跨龙门切割, 200.0)
            .put(工序.一跨数控切割, 200.0)
            .put(工序.二跨数控切割, 200.0)
            .put(工序.三跨数控切割, 200.0)
            .put(工序.三跨平铁切割, 200.0)
            .put(工序.手工切割, 200.0)

            .put(工序.坡口, 200.0)
            .put(工序.型材面板, 200.0)
            .put(工序.曲加工, 200.0)
            .put(工序.平铁打磨, 200.0)
            .put(工序.手工打磨, 200.0)
            .put(工序.预配盘, 200.0)
            .put(工序.光电结束, 200.0)
            .build();

    //相对于钢料需求期
    ImmutableMap<工序, Integer> 工序CD = ImmutableMap.<工序, Integer>builder()
            .put(工序.上料, -10)
            .put(工序.抛丸, -8)
            .put(工序.理料, -8)
            .put(工序.划线, -5)

            .put(工序.一跨龙门切割, -5)
            .put(工序.一跨数控切割, -5)
            .put(工序.二跨数控切割, -5)
            .put(工序.三跨数控切割, -5)
            .put(工序.三跨平铁切割, -5)
            .put(工序.手工切割, -5)

            .put(工序.坡口, -3)
            .put(工序.型材面板, -2)
            .put(工序.曲加工, -5)
            .put(工序.平铁打磨, -5)
            .put(工序.手工打磨, -5)
            .put(工序.预配盘, 0)
            .put(工序.光电结束, -3)
            .put(工序.配送, 0)
            .build();

    //来源数据库
//    ImmutableMap<String, 工序> 套料图工序对应关系 = ImmutableMap.of();
//            .<String, 工序>builder()
            //二跨超长超宽曲板小组
//            .put("10101019", 工序.上料)
//            .put("10101020", 工序.抛丸)
//            .put("10101021", 工序.理料)
//            .put("10101004", 工序.二跨数控切割)
//            .put("10101008", 工序.坡口)
//            .put("10101018", 工序.曲加工)
            //二跨超长超宽曲板中大组
//            .put("10111019", 工序.上料)
//            .put("10111020", 工序.抛丸)
//            .put("10111021", 工序.理料)
//            .put("10111004", 工序.二跨数控切割)
//            .put("10111008", 工序.坡口)
//            .put("10111018", 工序.曲加工)
//            .build();

    //来源数据库
    ImmutableMap<工序, Map<String, 设备>> 工序设备对应关系 = ImmutableMap.<工序, Map<String, 设备>>builder()
            //二跨超长超宽曲板小组
            .put(工序.上料, ImmutableMap.<String, 设备>builder()
                    .put("",new 设备01上料())
                    .build())
            .put(工序.抛丸, ImmutableMap.<String, 设备>builder()
                    .put("",new 设备02抛丸())
                    .build())
//            .put(工序.抛丸, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.理料, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.划线, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//
//            .put(工序.一跨龙门切割, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.一跨数控切割, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.二跨数控切割, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.三跨数控切割, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.三跨平铁切割, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//
//            .put(工序.坡口, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.型材面板, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.曲加工, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.平铁打磨, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.手工打磨, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.预配盘, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.光电结束, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
//            .put(工序.配送, new EmSbjbb[]{new EmSbjbb(), new EmSbjbb()})
            .build();
    @Getter
    @AllArgsConstructor
    enum 设备产能{
        SLSB01(工序.上料,"","",0,0,200.0,200.0,400),
        PWSB01(工序.抛丸,"","",0,0,240.0,286.0,526.0),
        LM01(工序.一跨龙门切割,"","",2.4,3.6,9.6,15.6,25.2),
        火焰01(工序.一跨数控切割,"","",0.3,11.5,2.0,0,2.0),
        数控01(工序.一跨数控切割,"","",1.5,3.0,0,8.5,25.5),
        ;
        public 工序 _工序;
        public String 设备编号;
        public String 设备名称;
        public double 单台效率;
        public double 单台产能;
        public double 白班设备产能;
        public double 二班设备产能;
        public double 双班合计产能;
    }

    @AllArgsConstructor
    enum 工序{
        NULL(""),
        上料("19"),
        抛丸("20"),
        理料("21"),
        划线("01"),
        一跨龙门切割("03"),一跨数控切割("04"),二跨数控切割("04"),三跨数控切割("04"),三跨平铁切割("05"),手工切割("06"),
        坡口("08"),
        型材面板("17"),
        曲加工("18"),
        平铁打磨("13"),手工打磨("16"),
        预配盘(""),
        光电结束(""),
        配送(""),
        ;

        @Getter
        private String code;

        //通过code获取工序
        public static 工序 getGxByCode(String code) {
            for (工序 gx : 工序.values()) {
                if (gx.getCode().equals(code)) {
                    return gx;
                }
            }
            return 工序.NULL;
        }

        //判断工序是否时NULL的
        public static boolean isNull(工序 gx) {
            return gx==工序.NULL;
        }
    }
}
