package com.dsic.gj_erp.pc;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.SpringContextHolder;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.pc.dto.gx.*;
import com.dsic.gj_erp.pc.dto.工序产能;
import com.dsic.gj_erp.pc.dto.排产结果;
import com.dsic.gj_erp.pc.dto.设备;
import com.dsic.gj_erp.pc.dto.资源;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.stream.Collectors;

import static com.dsic.gj_erp.pc.Constant.工序CD;
import static com.dsic.gj_erp.pc.Manager.*;

public class DataFactory {

    public static void 排产(){
        套料图所占工序的资源.clear();
        List<排产结果> list = 排产.list;
        list.clear();
        List<DmSygdxq> xqWithBom = getBean(DmSygdxqService.class).getXqWithBom(from, to);
        xqWithBom.forEach(xq->{
            xq.getBomList().forEach(bom->{
                Arrays.stream(Constant.工序.values()).forEach(gx->{
                    if (StrUtil.isEmpty(gx.getCode()))return;
                    if (ObjUtil.isNotEmpty(套料图工序对应关系.get(bom.getKw()+bom.getZl()+"_"+gx.getCode()))){
                        Integer cd = 工序CD.get(gx);
                        DateTime parse = DateUtil.parse(xq.getXzglxq(), "yyyy/MM/dd");
                        DateTime dateTime = DateUtil.offsetDay(parse, cd);
                        资源 _资源 = 提取资源(dateTime);
                        Optional.of(_资源).ifPresent(it->{
                            工序产能 工序产能=null;
                            资源 资源 = 套料图所占工序的资源.get(bom.getTzbh());
                            if (资源!=null){
                                工序产能 = 套料图所占工序的资源.get(bom.getTzbh()).get工序产能MAP().get(gx);
                            }
                            if (工序产能!=null&&工序产能.get资源占用图纸表().contains(bom.getTzbh())){
                                bom.set所在资源(_资源);
                            }else{
                                工序产能 = it.get工序产能MAP().get(gx);
                                //直接占用资源
                                工序产能.占用资源(bom.getTzbh(), bom.getTlsl().doubleValue());
                                bom.set所在资源(_资源);
                                套料图所占工序的资源.put(bom.getTzbh(),_资源);
                            }
                        });
                    }
                });
            });
        });
        System.out.println(111);
    }

    public static 资源 提取资源(Date date){
        资源 资源 = 资源池.get(DateUtil.format(date, "yyyy/MM/dd"));
        if (资源==null){
            return 提取资源(DateUtil.offsetDay(date,-1));
        }
        return 资源;
    }

    public static void 创建产能资源池(){
        资源池.clear();

        Map<Constant.工序, 工序产能> map=new HashMap<>();
        Arrays.stream(Constant.工序.values()).forEach(item->{
            if (StrUtil.isNotEmpty(item.getCode())){
                map.put(item,工序产能工厂(item));
            }
        });
        工厂日历.stream().filter(item -> "1".equals(item.getXxr()))
                .forEach(item -> 资源池.put(item.getGl(),资源.of(item.getGl(), map)));
    }

    public static 工序产能 工序产能工厂(Constant.工序 _工序){
        Map<String, 设备> _设备 = Constant.工序设备对应关系.get(_工序);
        switch (_工序){
            case 上料:
                return new 工序01上料(_工序,_设备);
            case 抛丸:
                return new 工序02抛丸(_工序,_设备);
            case 理料:
                return new 工序03理料(_工序,_设备);
            case 划线:
                return new 工序04划线(_工序,_设备);
            case 一跨龙门切割:
            case 一跨数控切割:
            case 二跨数控切割:
            case 三跨数控切割:
            case 三跨平铁切割:
            case 手工切割:
                return new 工序05切割(_工序,_设备);
            case 坡口:
                return new 工序07坡口(_工序,_设备);
            case 型材面板:
                return new 工序10型材(_工序,_设备);
            case 曲加工:
                return new 工序08曲面(_工序,_设备);
            case 平铁打磨:
            case 手工打磨:
                return new 工序09打磨(_工序,_设备);
//            case 预配盘:
//                return new 工序01上料(_工序,_设备);
//            case 光电结束:
//                return new 工序01上料(_工序,_设备);
//            case 配送:
//                return new 工序01上料(_工序,_设备);
            default:
                return new 工序99未知(_工序,_设备);
        }
    }

    public static void 加载工厂日历(){
        List<EmGcrl> list = getBean(EmGcrlService.class).getList(new JSONObject());
        工厂日历.clear();
        工厂日历.addAll(list);
    }

    public static void 加载套料图工序对应关系(){
        套料图工序对应关系.clear();
        List<EmSbcnp> list = getBean(EmSbcnpService.class).list();
        Map<String, List<EmSbcnp>> map = list.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()+"_"+l.getGx()));
        map.keySet().forEach(key->{
            String gxCode=key.split("_")[1];
            套料图工序对应关系.put(key,Constant.工序.getGxByCode(gxCode));
        });
    }

    public static void 加载设备信息(){
        List<EmSbjbb> deviceList = getBean(EmSbjbbService.class).list(Wrappers.<EmSbjbb>lambdaQuery().like(EmSbjbb::getScbs, "1"));
        设备列表.clear();
        设备列表.addAll(deviceList);
    }

    public static void 加载工序设备对应关系(){
        工序设备对应关系.clear();
        Arrays.stream(Constant.工序.values()).forEach(gx->{
            if (StrUtil.isNotEmpty(gx.getCode())){
                工序设备对应关系.putIfAbsent(gx, 设备列表.stream().filter(d->d.getGx().equals(gx.getCode())).collect(Collectors.toList()));
            }
        });
    }

    public static void 输出排产结果到EXCEL(OutputStream stream){

    }


    public static void 输出排产结果到EXCEL(String fileName){
        try(FileOutputStream fos=new FileOutputStream(fileName)) {
            输出排产结果到EXCEL(fos);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private static <T> T getBean(Class<T> clazz) {
        return SpringContextHolder.getBean(clazz);
    }
    private DataFactory(){}
}
