package com.dsic.gj_erp.pc.dto;

import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.service.工序排产处理接口;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;

@Getter
@Setter
public abstract class 工序产能 implements 工序排产处理接口 {
    protected Constant.工序 工序;
    protected double 白班时长;
    protected double 二班时长;
    protected double 产能;
    protected double 占用=0.0;
    protected int cd;
    protected Constant.工序 CD所对应的工序;//需要根据对应工序进行计算cd
    protected Map<String,设备> 设备;
    protected List<String> 资源占用图纸表;

    /**
     * 默认构造
     */
    public 工序产能(Constant.工序 工序, Map<String,设备> 设备){
        this.工序=工序;
        this.设备=设备;
        this.白班时长=7;
        this.产能=0;
        设备.values().forEach(item->{
            this.产能+=item.白班设备产能*this.白班时长+item.二班设备产能*this.二班时长;
        });
        this.产能=Constant.工序产能.get(工序);
        this.cd=Constant.工序CD.get(工序);
        资源占用图纸表=new ArrayList<>();
    }

    public 工序产能(Constant.工序 工序, Map<String,设备> 设备,double 白班时长,double 二班时长){
        this.工序=工序;
        this.设备=设备;
        this.白班时长=白班时长;
        this.二班时长=二班时长;
        this.产能=0;
        设备.values().forEach(item->{
            this.产能+=item.白班设备产能*this.白班时长+item.二班设备产能*this.二班时长;
        });
        this.cd=Constant.工序CD.get(工序);
        资源占用图纸表=new ArrayList<>();
    }

    public 设备 获取可占用设备(double 所需产能){
        return this.设备.values().stream()
                .filter(item -> this.判断设备是否可以占用(item.设备编号, 所需产能)).findFirst().orElse(null);
    }

    public boolean 判断设备是否可以占用(String 设备编号,double 所需产能){
        设备 _设备 = 设备.get(设备编号);
        return _设备.占用+所需产能<=_设备.产能;
    }

    public boolean 判断是否可以占用(double 所需产能){
        return this.占用+所需产能<=this.产能;
    }

    public void 占用资源(double 所需产能){
        this.占用=this.占用+所需产能;
    }

    public void 占用资源(String 占用源){
        this.资源占用图纸表.add(占用源);
    }

    @Override
    public void 占用设备(String 设备编号,String 占用源) {
        设备 _设备 = 设备.get(设备编号);
        _设备.资源占用图纸表.add(占用源);
    }
}
